package com.xy.service;

import cn.easyes.core.biz.EsPageInfo;
import cn.easyes.core.conditions.LambdaEsQueryWrapper;
import com.xy.dto.LogOperateDto;
import com.xy.entity.LogOperate;
import com.xy.mapper.LogOperateMapper;
import com.xy.utils.Emptys;
import com.xy.utils.EsQueryWrapper;
import com.xy.utils.PageBean;
import com.xy.utils.R;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import static com.xy.utils.EsBeans.toPageBean;

@Service
@AllArgsConstructor
@Api(tags = "操作日志")
public class LogOperateServiceImpl implements LogOperateService {

    private LogOperateMapper logOperateMapper;

    @PostMapping("page")
    @ApiOperation("分页查询")
    public R<PageBean<LogOperateDto.Vo>> page(@RequestBody LogOperateDto.Page page) {
        PageBean pageBean = page.getPage();
        LambdaEsQueryWrapper<LogOperate> lambdaEsQueryWrapper = new EsQueryWrapper().eqWrapper(page, LogOperate.class)
                .ge(LogOperate::getCreateTime, page.getBeginCreateTime())
                .le(LogOperate::getCreateTime, page.getEndCreateTime())
                .like(LogOperate::getLogContent)
                .build()
                .orderByDesc(!Emptys.check(pageBean.getOrders()), LogOperate::getCreateTime);
        EsPageInfo<LogOperate> esPageInfo = logOperateMapper.pageQuery(lambdaEsQueryWrapper, (int) pageBean.getCurrent(), (int) pageBean.getSize());
        return R.ok(toPageBean(LogOperateDto.Vo.class, esPageInfo));
    }

}
